class cl {
    static svgVersion = 'xmlns="http://www.w3.org/2000/svg" version="1.1"';

    static #tropfen = `<path stroke="#66a1ba" fill="#66a1ba" d="M 0,-43.0 a 215.0,215.0 0 0 1 -21.868,46.510 a 25.8,25.8 0 1 0 43.737,0 a 215.0,215.0 0 0 1 -21.868,-46.510 z" />"`;

    static GetSvg_Tropfen(x, y, width, height) {
        //x -=  width / 2;
        y += height / 5;
        return `<svg ${cl.svgVersion} width="${width}" height="${height}" transform="translate(${x},${y}) scale(1.2)" viewBox="-64 -64 128 128"><g stroke-width="6">${cl.#tropfen}</g></svg>`;
    }

    static GetSvg_Humidity(x, y, width, height) {
        //x -=  width / 2;
        y += height / 5;
        const txtX = -1 - (x + width / 2);
        const txtY = width / 2;
        return `<svg ${cl.svgVersion} width="${width}" height="${height}" transform="translate(${x},${y}) scale(1.2)" viewBox="-64 -64 128 128"><g stroke-width="6">${cl.#tropfen}</g><g stroke="black" fill="black" transform="scale(3)"><text x="${txtX}" y="${txtY}">%</text></g></svg>`;
    }

    static thermo2(x, y, scale = 1, color = "black", tempPro = 0.5) {
        let tSize = 50 * tempPro;
        let scaleX = 1.4 * scale;
        //x += 3;
        y += 10;
        // <svg ${cl.svgVersion} xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 100 100" enable-background="new 0 0 100 100" xml:space="preserve"></svg>
        let s = "";
        /*    s += `<g><defs>
            <linearGradient id="GrT" gradientTransform="rotate(90)" >
              <stop offset="20%" stop-color="red" />
              <stop offset="80%" stop-color="blue" />
            </linearGradient>
          </defs>`;
            color = `url(#GrT)`;*/

        s += `<g transform="scale(${scaleX},${scale}) translate(${x},${y})" stroke-width="1">`
        s += `<path fill=${color} d="M 29.004,65.316V10.146c0-0.006,0-0.023,0-0.036C28.978,4.528,24.434,0,18.854,0C13.262,0,8.724,4.528,8.698,10.111v55.205 C3.32,68.773,0,74.769,0,81.156c0,10.384,8.457,18.848,18.848,18.848c10.397,0,18.848-8.464,18.848-18.848 C37.695,74.769,34.375,68.766,29.004,65.316z M18.848,97.1c-8.789,0-15.95-7.148-15.95-15.944c0-5.638,3.06-10.918,7.981-13.776 l0.716-0.416V10.146c0-3.998,3.255-7.246,7.259-7.246c3.997,0,7.239,3.249,7.239,7.246v56.817l0.723,0.416 c4.922,2.852,7.988,8.139,7.988,13.776C34.805,89.952,27.644,97.1,18.848,97.1z"></path>`;
        s += `<path stroke-width="0" fill=${color} d="M 29.004,81.156 c0,5.599-4.544,10.149-10.156,10.149 c-5.612,0-10.149-4.551-10.149-10.149 c0-4.043,2.383-7.507,5.801-9.141 V 47.809 v15-${tSize} h8.704  v-15+${tSize} v24.206 C26.621,73.649,29.004,77.113,29.004,81.156 z"></path>`;
        //s += `<rect x="43.502" y="26.058" width="37.695" height="5.797"></rect>`;
        s += '</g>'
        return s;
    }

    static GetSvg_Thermo(x, y, width, height, tempCelsius) {
        function getRGBofTemp(t) {
            const TEMP_MIN = -10;
            const TEMP_MAX = 50;
            const FF = 255;
            if (t <= TEMP_MIN + 5) return ("rgb(126,42,255)");
            if (t >= TEMP_MAX) return ("rgb(255,0,255)");
            t = Math.round((t - TEMP_MIN) / (TEMP_MAX - TEMP_MIN) * 600);
            let m = Math.round((t / 100 - Math.floor((t - 1) / 100)) * 600);
            if (t == 0) m = 0;
            let n = m * 0.425;
            let r = 0;
            let g = 0;
            let b = 0;
            if (t <= 100) {
                r = Math.round(FF - n) + Math.floor(n / 4);
                g = Math.floor(n / 4);
                b = FF;
            } else if (t > 100 && t <= 200) {
                r = Math.floor(n / 4);
                g = Math.round(n) + Math.floor(n / 4);
                b = FF;
            } else if (t > 200 && t <= 300) {
                r = Math.floor(n / 4);
                g = FF;
                b = Math.round(FF - n);
            } else if (t > 300 && t <= 400) {
                r = Math.round(n + n / 4);
                g = FF;
            } else if (t > 400 && t <= 500) {
                r = FF;
                g = Math.round(FF - n);
            } else {
                r = FF;
                b = Math.round(n);
            }

            if (r > FF) r = FF;
            if (g > FF) g = FF;
            return "rgb(" + r + "," + g + "," + b + ")";
        }
        const color = getRGBofTemp(tempCelsius);
        let pro = tempCelsius / 40;
        if (pro > 1)
            pro = 1;
        if (pro < 0)
            pro = 0;

        // x +=  width / 2;
        y += height / 10;
        let s = `<svg ${cl.svgVersion} width="${width}" height="${height}" transform="scale(1) translate(${x},${y})" viewBox="0 0 60 110">`;
        s += cl.thermo2(0, 0, 1, color, pro);
        s += `</svg>`;
        return s;
    }

    //static SUN_COLOR0 = "#f6bc68"
    static SUN_COLOR = "#ffd700"
    static CLOUD_COLOR = "#828487"
    static RAIN_COLOR = "#66a1ba"
    //static WIND_COLOR = "#404040"
    static WIND_COLOR = "blue"

    static round2(wert) {
        return Math.round(wert * 1000) / 1000;
    }

    static WW_SVG1(width, height, x = 0, y = 0, add = "") {
        //debugger;
        return `<svg  ${cl.svgVersion} ${add} width="${width}" height="${height}" viewBox="-64 -64 128 128"><g stroke-width="3" transform="translate(${x},${y})">`;
    }

    static WW_SVG2 = `</g></svg>\n`;

    static sonne(x = 0, y = 0, r = 18) {
        const SUN_COLOR2 = "#fffbee"
        let s = "";
        let ro = r * 2 + 2;
        let fill = "none";
        let color = cl.SUN_COLOR;
        s += `<radialGradient id="Sonne_S${x}${y}${r}" cx="${x}" cy="${y}" r="${ro}" gradientUnits="userSpaceOnUse" >
    <stop offset="10%" stop-color="${cl.SUN_COLOR}"/>
    <stop offset="100%" stop-color="${SUN_COLOR2}" />
    </radialGradient>`;
        color = fill = `url(#Sonne_S${x}${y}${r})`;

        s += `<g stroke-width="1" stroke= "${color}" fill="${fill}">`;
        s += `<circle cx="${x}" cy="${y}" r="${r}" />`;
        s += `<path stroke-width="2" d="`;

        for (let i = 0; i < 8; i++) {
            const ri = r + 4;
            const w = Math.PI * i / 4;
            const x1 = cl.round2(x + Math.cos(w) * ri);
            const y1 = cl.round2(y + Math.sin(w) * ri);
            const x2 = cl.round2(x + Math.cos(w) * ro);
            const y2 = cl.round2(y + Math.sin(w) * ro);
            s += `M ${x1},${y1} L ${x2},${y2} `;
        }
        s += `" />`;
        s += `</g>`;
        return s;
    }

    static #mond(x = 0, y = 0, Moon = { proz: 0 }, scale = 1) {
        const MOON_COLOR = "lightgrey"; // "#808080"; // "#da4935"
        let proz = Math.round(Moon.proz / 2.5) * 2.5;
        //        let proz = Moon.proz;
        //        let cycle = (((proz / 25) - Math.floor(proz / 25))) * 20; 
        const ph = Math.floor(proz / 25);
        let cycle = Math.round((proz % 25) * 20) / 25; // this cycles between 0 and 20 4 times a month
        let arc = [[1, 0], [0, 0], [1, 1], [0, 1], [1, 0]]; // these arc-sweep options cycle
        let arUse = arc[ph];
        let lat = Moon.lat;
        if (!lat)
            lat = 51;
        let rot = 90;
        if (proz >= 50)
        lat *= 2;
        rot -= lat;

        switch (ph) {
            case 0:
            case 2:
            case 4:
                cycle = 20 - cycle;
                break;
        }
        scale *= 1.2;
        x -= 0;
        y -= 0;
        //arUse = arc[0];
        // 
        let s = `<g  transform="translate(${x},${y}) scale(${scale})">`;
        s += `<g transform="translate(-20,5) rotate(${rot},100,75)" stroke-width="4" stroke="black">`;
        //        s += `<path stroke-width="4" stroke="black" fill="none" d="m100,0 a20,20 0 1,1 0,150 a20,20 0 1,1 0,-150"/>`;
        s += `<circle  fill="none" cx="100" cy="75" r="75"/>`;
        s += `<path  fill="${MOON_COLOR}" d="m100,0 a${cycle},20 0 1,${arUse[0]} 0,150 a20,20 0 1,${arUse[1]} 0,-150"/>`;
        s += `</g>`;
        s += `</g>`;
        return s;
    }

    static GetSvg_Mond(x = 0, y = 0, width, height, moon) {
        let s = `<svg ${cl.svgVersion} width="${width}" height="${height}" transform="translate(${x},${y})" viewBox="0 0 200 200">`;
        s += cl.#mond(0, 0, moon, 1);
        s += `</svg>`;
        return s;
    }

    static wolke(x, y, scale = 1.0, color = cl.CLOUD_COLOR, fill = cl.CLOUD_COLOR) {
        //x -= (30 * scale);
        let s = "";
        s += `<g><defs>
                <linearGradient id="Gr${fill}" x1="0" x2="0" y1="0" y2="1">
                    <stop offset="0%" stop-color="white" />
                    <stop offset="100%" stop-color="${fill}" />
                </linearGradient>
            </defs>`;
        color = fill = `url(#Gr${fill})`;
        s += `<path stroke = "${color}" fill = "${fill}" d = "M ${x},${y} `;
        let xa = [20 * scale, 20 * scale, 4.88026841 * scale, -39.3954371 * scale];
        s += `a ${xa[0]},${xa[1]} 0 1 1 ${xa[2]},${xa[3]} `;
        xa = [24 * scale, 24 * scale, 43.20059379 * scale, -9.49083912 * scale];
        s += `a ${xa[0]},${xa[1]} 0 0 1 ${xa[2]},${xa[3]} `;
        xa = [16.25 * scale, 16.25 * scale, 16.9191378 * scale, 9.88627622 * scale];
        s += `a ${xa[0]},${xa[1]} 0 0 1 ${xa[2]},${xa[3]} `;
        xa = [20 * scale, 20 * scale, -6.244998 * scale, 39 * scale];
        s += `a ${xa[0]},${xa[1]} 0 0 1 ${xa[2]},${xa[3]} `;
        s += `z`
        s += `"/></g>`
        return s
    }

    static blitz(x, y) {
        // lightning 
        let s = `<path stroke-width="1" stroke-linejoin="round" stroke="darkred" fill="${cl.SUN_COLOR}" d="M ${x},${y} l9.125,-21.498 l-12.396,3.321 l7.141,-16.823 h-8.817 l-4.179,21.498 l12.395,-3.321 z" />`;
        return s
    }

    static regen(x = -28, y = 10, v = 30, anzahl = 3, color = cl.RAIN_COLOR) {
        // """ rain """
        let h = cl.round2(v * 22 / 30)
        x += (3 - anzahl) * 15 / 2;
        let s = `<g><path stroke="none" fill="${color}" d="M ${x},${y} `;
        for (let i = 0; i < anzahl; i++) {
            s += `h5 l ${h},${v} h-5 l -${h},-${v} z `;
            if (i < anzahl - 1) s += `m 15,0 `
        }
        s += `"/></g>`
        return s;
    }

    static schneeflocke(x, y, r, innen = true) {
        // """ snowflake """
        const PI_3 = Math.PI / 3;
        y -= r
        let sw = r * 0.15;
        let s = `<path stroke="${cl.RAIN_COLOR}" stroke-width="${sw}" stroke-linecap="round" fill="none" d="M ${x}, ${y} `;
        let xa;
        let ya;
        for (let i = 0; i < 3; i++) {
            let phi = i * PI_3;
            if (i > 0) {
                let ar = [cl.round2(-xa - r * Math.sin(phi)), cl.round2(-ya - r * Math.cos(phi))];
                s += `m ${ar[0]}, ${ar[1]} `;
            }
            let ar = [cl.round2(2 * r * Math.sin(phi)), cl.round2(2 * r * Math.cos(phi))];
            s += `l ${ar[0]},${ar[1]} `;
            xa = r * Math.sin(phi);
            ya = r * Math.cos(phi);
        }
        for (let i = 0; i < 6; i++) {
            let phi = i * PI_3;
            x = -r * Math.sin(phi);
            y = -r * Math.cos(phi);
            let ar = [cl.round2(x - xa), cl.round2(y - ya)];
            s += `m ${ar[0]}, ${ar[1]} `;
            let r2 = r / 3
            ar = [cl.round2(r2 * Math.sin(phi + PI_3)), cl.round2(r2 * Math.cos(phi + PI_3))];
            s += `m ${ar[0]}, ${ar[1]} `;
            ar = [cl.round2(r2 * Math.sin(phi + 5 * PI_3)), cl.round2(r2 * Math.cos(phi + 5 * PI_3))];
            s += `l ${ar[0]},${ar[1]} `;
            ar = [cl.round2(r2 * Math.sin(phi - 2 * PI_3)), cl.round2(r2 * Math.cos(phi - 2 * PI_3))];
            s += `l ${ar[0]},${ar[1]} `;
            ar = [cl.round2(r2 * Math.sin(phi + 2 * PI_3)), cl.round2(r2 * Math.cos(phi + 2 * PI_3))];
            s += `m ${ar[0]}, ${ar[1]} `;
            xa = x;
            ya = y;
        }
        if (innen) {
            for (let i = 0; i < 6; i++) {
                let phi = i * PI_3
                x = -r * 1.5 / 3 * Math.sin(phi);
                y = -r * 1.5 / 3 * Math.cos(phi);
                let ar = [cl.round2(x - xa), cl.round2(y - ya)];
                s += `m ${ar[0]}, ${ar[1]} `;
                let r2 = r / 6
                ar = [cl.round2(r2 * Math.sin(phi + PI_3)), cl.round2(r2 * Math.cos(phi + PI_3))];
                s += `m ${ar[0]}, ${ar[1]} `;
                ar = [cl.round2(r2 * Math.sin(phi + 5 * PI_3)), cl.round2(r2 * Math.cos(phi + 5 * PI_3))];
                s += `l ${ar[0]},${ar[1]} `;
                ar = [cl.round2(r2 * Math.sin(phi - 2 * PI_3)), cl.round2(r2 * Math.cos(phi - 2 * PI_3))];
                s += `l ${ar[0]},${ar[1]} `;
                ar = [cl.round2(r2 * Math.sin(phi + 2 * PI_3)), cl.round2(r2 * Math.cos(phi + 2 * PI_3))];
                s += `m ${ar[0]}, ${ar[1]} `;
                xa = x;
                ya = y;
            }
        }
        s += `" />`
        return s
    }

    static GetSvg_Schneeflocke(x, y, width, height) {
        //x -=  width / 2;
        y += height / 5;
        return cl.WW_SVG1(width, height, x, y, "") + cl.schneeflocke(x, y, 60, true) + cl.WW_SVG2;
    }

    static schlitterlinie(x, y, color = "#000000") {
        x -= 14.022;
        let s = `<path stroke="none" fill=${color} d="M ${x},${y} l8.54455967,-4.047423 `;
        // left
        s += "a 6.041,6.041 0 0 0 2.55,-8.646 l -3.237,-5.213 a 2.746,2.746 0 0 1 0.783,-3.715 l 4.939,-3.378 h -1.389 ";
        s += "l -5.108,2.936 a 4.683,4.683 0 0 0 -2.096,5.580 l 2.27,6.622 a 3.296,3.296 0 0 1 -1.845,4.110 l -13.743,5.753 z ";
        // right
        s += "m 33.333,0 l 1.228,-1.228 a 6.204,6.204 0 0 0 -1.285,-9.759 l -13.560,-7.829 a 3.226,3.226 0 0 1 -1.419,-3.897 l 0.832,-2.287 h -1.389 ";
        s += "l -0.681,1.083 a 4.682,4.682 0 0 0 1.302,6.306 l 12.493,8.590 a 2.689,2.689 0 0 1 0.134,4.333 l -5.989,4.687 z";
        s += '" />'
        return s
    }

    static nebel(x, y, scale = 0.5) {
        // """ fog """
        let s = `<g transform="scale(${scale})">`
        s += '<path stroke="rgba(111,155,164,90)" stroke-linecap="round" d="'
        for (let i = 0; i < 4; i++) {
            let next = y + (10 * i - 15);
            s += `M ${x},${next} h 78 `
        }
        s += '" />'
        s += '</g>'
        return s
    }

    static windsymbol(wx, wy, factor = 1, color = cl.WIND_COLOR, stufe = 3) {
        if (stufe >= 4)
            color = "red";
        let r = cl.round2(12 * factor)
        let xa = [cl.round2(6 * factor), color,
            wx, wy - 15 * factor, 40 * factor, r, r, -r, -r,
            wx, wy, 75 * factor, r, r, -r, -r,
            wx, wy + 15 * factor, 57.5 * factor, r, r, -r, r];
        let s = '<g>';
        s += `<path opacity="0.5" stroke-width="${xa[0]}" stroke="${xa[1]}" fill="none" d="`;
        if (stufe >= 3)
            s += `M ${xa[2]},${xa[3]} h ${xa[4]} a ${xa[5]},${xa[6]} 0 1 0 ${xa[7]},${xa[8]} `;
        s += `M ${xa[9]},${xa[10]} h ${xa[11]} a ${xa[12]},${xa[13]} 0 1 0 ${xa[14]},${xa[15]} `;
        if (stufe >= 2)
            s += `M ${xa[16]},${xa[17]} h ${xa[18]} a ${xa[19]},${xa[20]} 0 1 1 ${xa[21]},${xa[22]}`;
        s += `" />`
        s += '</g>';
        return s;
    }

    static schleudergefahr(x = 0, y = 0, scale = 0.5) {
        //""" traffic sign like """
        let b = 84
        let h = b * 0.5
        let v = cl.round2(b * Math.sin(60 * Math.PI / 180))
        let s = `<g transform="scale(${scale})">`
        s += `<path stroke="#F0F0F0" stroke-width="16" stroke-linejoin="round" fill="#F0F0F0" d="M ${x},${y} l ${h},-${v} l ${h},${v} z" />`;
        v = cl.round2(b * Math.sin(60 * Math.PI / 180))
        s += `<path stroke="#b52126" stroke-width="12" stroke-linejoin="round" fill="white" d="M ${x},${y} l ${h},-${v} l ${h},${v} z" />`;
        s += cl.schlitterlinie(x + b / 2, y - 10);
        s += '</g>'
        return s
    }

    static #svg_wetter(
        Stufe = {
            IsTag: undefined, wind: 0, Achtel_m8: 0,
            Sandsturm_m3: 0, Schauer_m3: 0, Regen_m3: 0, SchneeRegen_m2: 0, Schnee_m3: 0, Niesel_m3: 0,
            Glaette_b: false, Nebel_b: false, Blitz_b: false, Hagel_b: false
        }, idCall = null) {

        let id = "";

        let mit_sonne = false;
        let mit_mond = false;

        if (!Stufe.Achtel_m8)
            Stufe.Achtel_m8 = 0;

        if (Stufe.Achtel_m8 < 8) {
            switch (Stufe.IsTag) {
                case 1:
                case true:
                    mit_sonne = true;
                    id += "SM-S";
                    break;
                case 0:
                case false:
                    mit_mond = true;
                    id += "SM-M";
                    break;
                default:
                    id += "SM-0";
                    break;
            }
        }
        else
            id += "SM-W";
        id += "_";

        if (Stufe.Sandsturm_m3 > 0) {
            Stufe.wind = 0;
            Stufe.Regen_m3 = 0;
            Stufe.Schauer_m3 = 0;
            Stufe.SchneeRegen_m2 = 0;
            Stufe.Schnee_m3 = 0;
            Stufe.Niesel_m3 = 0;
            Stufe.Hagel_b = 0;
            Stufe.Glaette_b = 0;
        }

        if (Stufe.Blitz_b || Stufe.Hagel_b || Stufe.Schauer_m3 || Stufe.Regen_m3 || Stufe.SchneeRegen_m2 || Stufe.Schnee_m3 || Stufe.Niesel_m3)
            if (Stufe.Achtel_m8 < 1)
                Stufe.Achtel_m8 = 1;

        function sMond(x, y, scale = 1) {
            scale *= 0.2;
            let s = "";
            //            s += cl.sonne(x, y, 15);
            x -= 200 / 2 * scale;
            y -= 200 / 2 * scale;
            s += cl.#mond(x, y, Stufe.Moon, scale);
            return s;
        }

        function addSymSub(x, y) {
            //x += 22;
            //y += -22;
            let add = "";

            let W_m4 = cl.StufeWind(Stufe.wind)
            if (W_m4 >= 1) {
                let useY = y - 25;
                let useX = x;
                switch (Stufe.Achtel_m8) {
                    case 0:
                        useX += 5;
                        useY -= 30;
                        break;
                    case 1:
                    case 2:
                        useX += 28;
                        useY -= 25;
                        break;
                    case 3:
                        // useX += 0;
                        useY += 12;
                        break;
                    case 4:
                        useY += 10;
                        break;
                    case 5:
                        // useX += 0;
                        useY += 8;
                        break;
                }
                id += "AW-" + W_m4 + "_";
                add += cl.windsymbol(useX, useY, 0.5, cl.WIND_COLOR, W_m4);
            }

            if (Stufe.Nebel_b) {
                id += "AN_";
                add += cl.nebel(x - 18, y + 40, 0.6);
            }

            if (Stufe.Blitz_b) {
                id += "AB_";
                add += cl.blitz(0 + 5, y + 25);
            }
            if (Stufe.Sandsturm_m3 > 0) {
                // SAND_COLOR #a95c33 #a96132 #a47137
                const SAND_COLOR = "#a96132"
                id += "As-" + Stufe.Sandsturm_m3 + "_";
                return cl.windsymbol(x, y, 0.5, SAND_COLOR, Stufe.Sandsturm_m3) + add;
            }
            if (Stufe.Glaette_b) {
                id += "AG_";
                //add = schleudergefahr(x + 95, y - 100, 0.4);
                add += cl.schleudergefahr(x + 40, y - 50, 0.5);
            }

            if (Stufe.Hagel_b) {
                id += "AH_";
                function hagel(x, y) {
                    // """ hail """
                    let xy1 = [x - 15, y + 37];
                    let xy2 = [x - 6, y + 19];
                    let xy3 = [x + 11, y + 30];
                    let s = `<g stroke="none" fill="${cl.RAIN_COLOR}">`;
                    s += `<circle cx="${xy1[0]}" cy="${xy1[1]}" r="5" />`
                    s += `<circle cx="${xy2[0]}" cy="${xy2[1]}" r="5" />`
                    s += `<circle cx="${xy3[0]}" cy="${xy3[1]}" r="5" />`
                    s += '</g>'
                    return s
                }
                add += hagel(x + 25, y - 10);
                return add;
            }

            const schneeX = 0;
            const schneeY = 10;
            switch (Stufe.Schnee_m3) {
                case undefined:
                case 0:
                    break;
                case 1:
                    id += "AS-1_";
                    return cl.schneeflocke(schneeX + x + 20, schneeY + y + 7, 10, true) + add;
                case 2:
                    id += "AS-2_";
                    return cl.schneeflocke(schneeX + x + 9, schneeY + y + 7, 10, false) + cl.schneeflocke(schneeX + x + 34, schneeY + y, 10, false) + add;
                case 3:
                    id += "AS-3_";
                    return cl.schneeflocke(schneeX + x + 9, schneeY + y + 7, 10, false) + cl.schneeflocke(schneeX + x + 34, schneeY + y, 10, false) + cl.schneeflocke(schneeX + x + 28, schneeY + y + 20, 10, true) + add;
                default:
                    console.log("Stufe.Regen");
                    break;
            }

            switch (Stufe.SchneeRegen_m2) {
                case undefined:
                case 0:
                    break;
                case 1:
                    id += "AF-1_";
                    return cl.schneeflocke(schneeX + x + 12, schneeY + y + 6, 10, false) + cl.regen(schneeX + x + 6, schneeY + y - 12, 30, 1) + add;
                case 2:
                    id += "AF-2_";
                    return cl.schneeflocke(schneeX + x + 12, schneeY + y + 6, 10, false) + cl.regen(schneeX + x + 12, schneeY + y - 12, 30, 2) + add;
                default:
                    console.log("Stufe.Regen");
                    break;
            }

            if (Stufe.Regen_m3 > 0) {
                id += "AR-" + Stufe.Regen_m3 + "_";
                return cl.regen(x, y, 30, Stufe.Regen_m3) + add;
            }
            if (Stufe.Schauer_m3 > 0) {
                id += "Ar-" + Stufe.Schauer_m3 + "_";
                function Schauer(x = -28, y = 10, v = 30, anzahl = 3) {
                    // """ drizzle """
                    let h = cl.round2(v * 22 / 30)
                    //let dash = (v / 13 > 2.2) ? "10 4" : "10 5"
                    let dash = "10 2";

                    x += (6 - anzahl) * 15 / 2;
                    y += v
                    let s = `<path stroke="${cl.RAIN_COLOR}" fill="none" stroke-dasharray="${dash}" stroke-width="4" d="M ${x},${y} `;
                    for (let i = 0; i < anzahl; i++) {
                        let sign = (i % 2) ? 1 : -1
                        let ar = [h * sign, v * sign];
                        s += `l ${ar[0]},${ar[1]} `;
                        if (i < anzahl - 1) s += `m 15,0 `;
                    }
                    s += `" />`
                    return s
                }
                return Schauer(x, y, 30, Stufe.Schauer_m3) + add;
            }
            if (Stufe.Niesel_m3 > 0) {
                id += "AN-" + Stufe.Niesel_m3 + "_";
                function niesel(x = -28, y = 10, v = 30, anzahl = 5) {
                    // """ drizzle """
                    let h = cl.round2(v * 22 / 30)
                    let dash = (v / 13 > 2.2) ? "4 9" : "3.5 7.5"
                    x += 1.5 + h
                    x += (6 - anzahl) * 7.5 / 2 - 7.5;
                    y += v
                    let s = `<path stroke="${cl.RAIN_COLOR}" fill="none" stroke-dasharray="${dash}" stroke-width="2" d="M ${x},${y} `;
                    for (let i = 0; i < anzahl; i++) {
                        let sign = (i % 2) ? 1 : -1
                        let ar = [h * sign, v * sign];
                        s += `l ${ar[0]},${ar[1]} `;
                        if (i < anzahl - 1) s += `m 7.5,0 `;
                    }
                    s += `" />`
                    return s
                }
                return niesel(x, y, 30, Stufe.Niesel_m3 * 2) + add;
            }

            return add;
        }

        function addSym(x, y) {
            let s = addSymSub(x, y);
            if (idCall)
                idCall(s, Stufe);
            return s;
        }

        //debugger;
        if (Stufe.Achtel_m8 == 0) {
            // # clear day or night
            if (!mit_sonne && !mit_mond) {
                function sonnemondicon() {
                    let s = "";
                    s += "<g>";
                    s += sMond(20, -25, 0.5);
                    s += cl.sonne(-10, -5, 10);
                    s += "</g>";
                    return s;
                }
                return sonnemondicon() + addSym(13, 24);
            }
        }

        if (Stufe.Achtel_m8 == 8) {
            mit_sonne = mit_mond = false;
        }

        let s = ""
        let xy = [-31, 28];
        switch (Stufe.Achtel_m8) {
            case 0:
                xy = [-2, 15]
                if (mit_sonne)
                    s += cl.sonne(-21, -18, 18);
                if (mit_mond)
                    s += sMond(-21, -18);
                break;
            case 1:
            case 2:
                {
                    xy = [-25, 60];
                    if (mit_sonne)
                        s += cl.sonne(-21, -18, 18);
                    if (mit_mond)
                        s += sMond(-21, -18);
                    break;
                }
            case 3:
            case 4:
            case 5:
                xy = [-25, 20];
                if (mit_sonne)
                    s += cl.sonne(-32, -18, 14);
                if (mit_mond)
                    s += sMond(-32, -18)
                break;
            case 6:
            case 7:
                if (mit_sonne)
                    s += cl.sonne(-28, -12, 14);
                if (mit_mond)
                    s += sMond(-28, -12 - 8);
                //xy = [-25, 28]
                break;
        }

        id += "W-" + Stufe.Achtel_m8 + "_";
        if (Stufe.Achtel_m8 >= 6) {
            // 2. wolke
            // mostly cloudy day or night or overcast
            s += cl.wolke(0, 0, 0.6, "#A2A4A7", "#707070");
        }

        if ((Stufe.Achtel_m8 > 0) && (Stufe.Achtel_m8 <= 2)) {
            // mostly clear day or night-- > small cloud
            let addX = xy[0] + 13;
            let addY = xy[1] - 48;
            let scale = 0.4;
            if (Stufe.Achtel_m8 == 2)
                scale = 0.5;
            s += cl.wolke(xy[0] + 20, xy[1] - 45, scale, "#A2A4A7", "#D3D3D3");
            s += addSym(addX, addY);
        }
        if (Stufe.Achtel_m8 > 2) {
            // large cloud
            let scale = Stufe.Achtel_m8 / 8 * 0.5;
            s += cl.wolke(xy[0] + (0.5 - scale) * 30, xy[1] - (0.5 - scale) * 15, 0.5 + scale);
            s += addSym(xy[0] + 8, xy[1] - 4 - (0.5 - scale) * 15);
        }
        if (Stufe.Achtel_m8 == 0) {
            s += addSym(xy[0], xy[1]);
        }
        return s
    }

    static GetSvg_Wetter(x = 0, y = 0, width, height, Stufe, add, idCall = null) {
        const start = cl.WW_SVG1(width, height, x, y, add);
        const end = cl.WW_SVG2;
        const svg = cl.#svg_wetter(Stufe, idCall);
        if (!svg) {
            console.log(Stufe);
            //svg_wetter(Stufe, idCall);
        }
        return `${start}${svg}${end}`;
    }

    static GetSvg_Sonne(x = 0, y = 0, width, height) {
        let s = `<svg ${cl.svgVersion} width="${width}" height="${height}" transform="scale(1) translate(${x},${y})" viewBox="-40 -40 80 80">`;
        s += cl.sonne(0, 2, 18);
        s += `</svg>`;
        return s;
    }

    static StufeWind(wind_km_h) {
        const wind = Math.round(wind_km_h);
        let st = 0;
        if (wind > 19) // mäßiger Wind
            st = 1;
        if (wind > 38) // starker Wind
            st = 2;
        if (wind > 61) // stürmischer Wind
            st = 3;
        if (wind > 74) // Sturm
            st = 4;
        return st;
    }

    static GetSvg_Wind(x = 0, y = 0, width, height, deg, wind_km_h) {
        deg += 180;
        let s = `<?xml version="1.0"?><svg xmlns="http://www.w3.org/2000/svg" width="${width}" height="${height}" transform="scale(1.1) translate(${x},${y})" viewBox="-10 -25 60 50">`;
        if (wind_km_h < 5) {
            //            console.log(wind_km_h);
            s += `<g transform="translate(10,-24.8) scale(1.6,1.6)"><circle cx="6" cy="15.5" r="15" fill="none" stroke="green"/></g>`;
            s += `</svg>`;
            return s;
        }

        let anz = cl.StufeWind(wind_km_h);
        let col = (anz >= 4) ? "#B21807" : "LightSkyBlue";
        let fak = Math.round(Math.max(1, 5 * Math.min(80, wind_km_h) / 80) * 10) / 10;
        let breite = Math.round(1.6 * fak * 100) / 100;
        let rotX = Math.round(6 * 1.6 * fak * 100) / 100;
        let xR = Math.round((10 - 10 * (fak - 1)) * 100) / 100;
        //s += `<path stroke-width="3" stroke="blue" fill="none" opacity="0.5" d="M 4,-3.5 h 20 a 6,6 0 1 0 -6,-6 M 4,4 h 37.5 a 6,6 0 1 0 -6,-6 M 4,11.5 h 28.75 a 6,6 0 1 1 -6,6" />`;
        //        s += `<g transform="translate(10,-24.8) rotate (30,9.6,24.8) scale(1.6,1.6)"><circle cx="6" cy="15.5" r="15" fill="none" stroke="green"/><path fill="black" d="m 4,1 v 20 H 1 l 5,9 5-9 H 8 V1" /></g>`;
        s += `<g transform="translate(${xR},-24.8) rotate (${deg},${rotX},24.8) scale(${breite},1.6)"><path fill="${col}" d="m 4,1 v 20 H 1 l 5,9 5-9 H 8 V1"/></g>`;
        //        s += `<g transform="translate(10,-20) rotate(${deg},10,20) scale(1.6,1.6)"><path fill=""${col}" d="m 4,1 v 20 H 1 l 5,6 5-6 H 8 V1"/></g>`;
        /*        if (anz)
                    s += cl.windsymbol(0, 0, 0.5, cl.WIND_COLOR, anz);*/
        s += `</svg>`;
        return s;
    }

    static GetSvg_WMO2700N(id = 0, x, y, width, height, svg = true) {
        if ((id < 0) || (id > 10))
            return "";
        const arr = [
            '"none"/>',
            '"none"/> <line x1="50" y1="5" x2="50" y2="95" stroke-width="8" stroke="#000000" />',
            '"none"/> <path d="M 95,50 L 50,50 L 50,5 A 45 45 0 0 1 95,50 Z" stroke="none" fill="#000000" />',
            '"none"/> <path d="M 95,50 L 50,50 L 50,5 A 45 45 0 0 1 95,50 Z" stroke="none" fill="#000000" /> <line x1="50" y1="5" x2="50" y2="95" stroke-width="8" stroke="#000000" />',
            '"none"/> <path d="M 50,95 L 50,5 A 45 45 0 0 1 50,95 Z" stroke="none" fill="#000000" />',
            '"none"/> <line x1="5" y1="50" x2="95" y2="50" stroke-width="8" stroke="#000000" /> <path d="M 50,95 L 50,5 A 45 45 0 0 1 50,95 Z" stroke="none" fill="#000000" />',
            '"none"/> <path d="M 5,50 L 50,50 L 50,5 A 45 45 0 1 1 5,50 Z" stroke="none" fill="#000000" />',
            '"none"/> <path d="M 60,93.875 L 60,6.125 A 45 45 0 0 1 60,93.875 Z M 40,6.125 L 40,93.875 A 45 45 0 0 1 40,6.125 Z" stroke-width="8" stroke="#000000" fill="#000000" />',
            '"#000000"/>',
            '"none"/> <line x1="18.180" y1="18.180" x2="81.820" y2="81.820" stroke-width="8" stroke="#000000" /> <line x1="18.180" y1="81.8198" x2="81.8198" y2="18.180" stroke-width="8" stroke="#000000" />',
            '"none"/> <line x1="5" y1="50" x2="95" y2="50" stroke-width="8" stroke="#000000" /> <line x1="50" y1="5" x2="50" y2="95" stroke-width="8" stroke="#000000" />',
        ];
        const s = `<desc>WMO 2700 N ${id}/8</desc> <circle cx="50" cy="50" r="45" stroke-width="8" stroke="#000000" fill=` + arr[id];
        if (!svg) {
            let scale = width / 50;
            return `<g transform="scale(${scale}) translate(${x},${y})">${s}</g>`;
        }
        return `<svg ${cl.svgVersion} width="${width}" height="${height}" viewBox="0 0 100 100" <g transform="translate(${x},${y})">${s}</g></svg>`;
    }
}

class inCl {
    static id = 1;

    static addI(aa) {
        this.id++;
        return `<i id="xZ${this.id}"><script>{document.getElementById("xZ${this.id}").innerHTML = ${aa};}</script></i>`;
    }

    static GetSvg_Humidity(x, y, width, height) {
        return this.addI(`cl.GetSvg_Humidity (${x},${y},${width},${height})`)
    }

    static GetSvg_Thermo(x, y, width, height, tempCelsius) {
        return this.addI(`cl.GetSvg_Thermo (${x},${y},${width},${height}, ${tempCelsius})`)
    }

    static GetSvg_Wind(x = 0, y = 0, width, height, deg, wind_km_h) {
        return this.addI(`cl.GetSvg_Wind (${x},${y},${width},${height}, ${deg}, ${wind_km_h})`)
    }

    static GetSvg_Sonne(x = 0, y = 0, width, height) {
        return this.addI(`cl.GetSvg_Sonne (${x},${y},${width},${height})`)
    }

    static shortMoon(moon) {
        return { "proz": moon.proz, "lat": moon.lat };
    }

    static GetSvg_Mond(x = 0, y = 0, width, height, moon) {
        const mm = JSON.stringify(this.shortMoon(moon));
        return this.addI(`cl.GetSvg_Mond (${x},${y},${width},${height}, ${mm})`)
    }

    static GetSvg_Wetter(x = 0, y = 0, width, height, Stufe) {
        Stufe.Moon = this.shortMoon(Stufe.Moon);
        const mm = JSON.stringify(Stufe);
        return this.addI(`cl.GetSvg_Wetter (${x},${y},${width},${height}, ${mm})`)
    }

    static GetSvg_WMO2700N(id = 0, x, y, width, height, svg = true) {
        return this.addI(`cl.GetSvg_WMO2700N (${id},${x},${y},${width},${height},${svg})`);
    }
}

function GetSvg_WetterWarnung(x = 0, y = 0, width, height, typ, farbe) {
    function warnung(x = 0, y = 0, typ, color = "#b52126", scale = 1) {
        //""" traffic sign like """
        let b = 84
        let h = b * 0.5
        let v = cl.round2(b * Math.sin(60 * Math.PI / 180));
        let s = `<g transform="scale(${scale})">`
        s += `<path stroke="#F0F0F0" stroke-width="16" stroke-linejoin="round" fill="#F0F0F0" d="M ${x},${y} l ${h},-${v} l ${h},${v} z" />`;
        v = cl.round2(b * Math.sin(60 * Math.PI / 180))
        s += `<path stroke="${color}" stroke-width="12" stroke-linejoin="round" fill="white" d="M ${x},${y} l ${h},-${v} l ${h},${v} z" />`;
        switch (typ) {
            case 0:
            case 'gewitter':
                s += cl.wolke(x + b / 2 - 8, y - 20, 0.3);
                s += cl.blitz(x + b / 2, y - 10);
                break;

            case 1:
            case 'sturm':
                s += cl.windsymbol(x + b / 4 + 7, y - b / 4 - 1, 0.35, cl.WIND_COLOR, 3);
                break;

            case 2:
            case 'regen':
                {
                    //s += cl.regen(x + 35, y - 35, v = b/4, stufe = 3);
                    let raX = x + b / 2 + 15;
                    let raY = y - b / 2 - 25;
                    let trX = x + b + 50;
                    let trY = y - b;
                    s += `<g stroke-width="6" stroke="#F0F0F0" transform="scale(0.3) translate(${trX},${trY})">` + cl.tropfen + '</g>';
                    s += `<g stroke-width="6" transform="scale(0.5) translate(${raX},${raY})">` + cl.regen(0, 0, b / 2, 3, "blue") + '</g>';
                }
                break;

            case 3:
            case 'schnee':
                {
                    let schneeSize = 11;
                    let schneeX = x + b / 2;
                    let schneeY = y - b / 2 - schneeSize / 2;

                    s += `<g transform="scale(0.8) translate(${schneeX},${schneeY})">`
                        + cl.schneeflocke(-1 * schneeSize / 2, 5 * schneeSize / 2, schneeSize, false)
                        + cl.schneeflocke(4 * schneeSize / 2, 4 * schneeSize / 2, schneeSize, false)
                        + cl.schneeflocke(2 * schneeSize / 2, 0 * schneeSize / 2, schneeSize, true) + '</g>';
                }
                break;

            case 4:
            case 'nebel':
                s += cl.nebel(x + b - 15, y - b / 2 - 4, 0.4);
                break;

            case 5:
            case 'frost':
                {
                    let xOff = 100 - 10;
                    let yOff = -30;
                    let trX = x + xOff / 2 + 5;
                    let trY = y + yOff + 5;
                    //s += `<g stroke-width="6" transform="scale(0.2) translate(${trX},${trY})">` + cl.tropfen + '</g>';
                    s += cl.thermo2(x + b / 2 + 25, y - 82 - 15 + yOff, 0.3, "blue", 0.1);
                    s += cl.schneeflocke(trX, trY, 8);
                }
                break;

            case 6:
            case "glatteis":
                s += cl.schneeflocke(x + b / 2, y - 35, 9);
                s += cl.schlitterlinie(x + b / 2, y - 10, "grey");
                break;

            case 7:
            case 'tauwetter':
                {
                    let xOff = 100;
                    let yOff = -30;
                    let trX = x + b + xOff + 70;
                    let trY = y + yOff - 90;
                    //s += `<g stroke-width="6" transform="scale(0.2) translate(${trX},${trY})">` + cl.tropfen + '</g>';
                    s += cl.thermo2(x + b / 2 + 25, y - 82 - 15 + yOff, 0.3, "#E9AB17", 0.4);
                    s += `<g stroke-width="6" transform="scale(0.2) translate(${trX},${trY})">` + cl.tropfen + '</g>';
                }
                break;

            case 8:
            case 'hitze':
                let xOff = 100 - 10;
                let yOff = -30;
                s += `<g transform="scale(0.3)">`
                s += cl.sonne(x + b + xOff - 10, y - 55 + yOff, 18);
                s += '</g>'
                s += cl.thermo2(x + b / 2 + 25, y - 82 - 15 + yOff, 0.3, "red", 1);
                break;

            case 9:
            case 'uv':
                {
                    let xOff = 23;
                    let yOff = -10;
                    s += `<g stroke-width="1" stroke="black" transform="scale(1.2)"><text x="${xOff}" y="${yOff}" fill="black">UV</text></g>`;
                }
                break;

            case 10:
            case 'kueste':
                {
                    let xOff = 22;
                    let yOff = -10;
                    s += `<g transform="scale(1)"><text x="${xOff}" y="${yOff}"  fill="black">Küste</text></g>`;
                }
                break;

            case 11:
            case 'binnensee':
                {
                    let xOff = 22;
                    let yOff = -10;
                    s += `<g transform="scale(1)"><text x="${xOff}" y="${yOff}"  fill="black">See</text></g>`;
                }
                break;
            default:
                console.error("warnung typ: " + typ);
                break;
        }
        s += '</g>'
        return s
    }
    const start = cl.WW_SVG1(width, height, x - width / 2, y + height / 2);
    const end = cl.WW_SVG2;
    const svg = warnung(0, 0, typ, farbe);
    return `${start}${svg}${end}`;
}

function GetSvg_WetterTest() {
    let IsTag = true;
    let idObj = {};
    function checkId(id, stufe) {
        delete stufe.Moon;
        delete stufe.IsTag;
        for (const id of Object.keys(stufe)) {
            if (stufe[id] == 0)
                delete stufe[id];
        }
        if (!idObj[id]) {
            idObj[id] = stufe;
        }
    }
    let s = "";
    var Achtel_m8 = 0;
    //var Achtel_m8; for (Achtel_m8 = 0; Achtel_m8 <= 8; Achtel_m8++)
    {
        var wind; for (wind = 0; wind <= 80; wind += 20) {
            var Schauer_m3; for (Schauer_m3 = 0; Schauer_m3 <= 3; Schauer_m3++) {
                var Regen_m3; for (Regen_m3 = 0; Regen_m3 <= 3; Regen_m3++) {
                    var SchneeRegen_m2; for (SchneeRegen_m2 = 0; SchneeRegen_m2 <= 2; SchneeRegen_m2++) {
                        var Schnee_m3; for (Schnee_m3 = 0; Schnee_m3 <= 3; Schnee_m3++) {
                            var Niesel_m3; for (Niesel_m3 = 0; Niesel_m3 <= 3; Niesel_m3++) {
                                var Glaette_b; for (Glaette_b = 0; Glaette_b <= 1; Glaette_b++) {
                                    var Nebel_b; for (Nebel_b = 0; Nebel_b <= 1; Nebel_b++) {
                                        var Blitz_b; for (Blitz_b = 0; Blitz_b <= 1; Blitz_b++) {
                                            var Hagel_b; for (Hagel_b = 0; Hagel_b <= 1; Hagel_b++) {
                                                var Sandsturm_m3; for (Sandsturm_m3 = 0; Sandsturm_m3 <= 3; Sandsturm_m3++) {
                                                    cl.GetSvg_Wetter(0, 0, 50, 50,
                                                        {
                                                            Moon: { proz: 0 }, IsTag: IsTag,
                                                            wind: wind, Achtel_m8: Achtel_m8,
                                                            Sandsturm_m3: Sandsturm_m3, Schauer_m3: Schauer_m3, Regen_m3: Regen_m3, SchneeRegen_m2: SchneeRegen_m2, Schnee_m3: Schnee_m3, Niesel_m3: Niesel_m3,
                                                            Glaette_b: Glaette_b, Nebel_b: Nebel_b, Blitz_b: Blitz_b, Hagel_b: Hagel_b
                                                        }, "", checkId);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    let arr = [];
    for (const id of Object.keys(idObj)) {
        arr.push(idObj[id]);
    }
    //console.log("Anzahl: " + Object.keys(idObj).length);
    return arr;
}

module.exports = {
    cl, inCl, GetSvg_WetterTest, GetSvg_WetterWarnung
};
